#ifndef _CFG_H_
#define _CFG_H_

#include <gctypes.h>

#ifdef __cplusplus
extern "C"
{
#endif

#include "usbloader/disc.h"

#define CFG_VIDEO_SYS   0  // system default
#define CFG_VIDEO_DEFAULT  1
#define CFG_VIDEO_GAME  1  // game default
#define CFG_VIDEO_PATCH 2  // patch mode
#define CFG_VIDEO_PAL50	3  // force PAL
#define CFG_VIDEO_PAL60	4  // force PAL60
#define CFG_VIDEO_NTSC	5  // force NTSC
#define CFG_VIDEO_COUNT 6

#define CFG_LANG_CONSOLE  0
#define CFG_LANG_JAPANESE 1
#define CFG_LANG_ENGLISH  2
#define CFG_LANG_GERMAN   3
#define CFG_LANG_FRENCH   4
#define CFG_LANG_SPANISH  5
#define CFG_LANG_ITALIAN  6
#define CFG_LANG_DUTCH    7
#define CFG_LANG_S_CHINESE 8
#define CFG_LANG_T_CHINESE 9
#define CFG_LANG_KOREAN   10
#define CFG_LANG_COUNT    11

#define CFG_ALIGN_LEFT 0
#define CFG_ALIGN_RIGHT 1
#define CFG_ALIGN_CENTRE 2
#define CFG_ALIGN_TOP 3
#define CFG_ALIGN_BOTTOM 4
#define CFG_ALIGN_MIDDLE 5

extern char bootDevice[10];
//extern char *cfg_path;

extern u8 ocarinaChoice;
extern u16 playcnt;
extern u8 videoChoice;
extern u8 languageChoice;
extern u8 viChoice;
extern u8 iosChoice;
extern u8 parentalcontrolChoice;
extern u8 fix002;
extern u8 reloadblock;
extern u8 countrystrings;
extern u8 alternatedol;
extern u32 alternatedoloffset;
extern char alternatedname[40];

struct Game_CFG
{
	u8 id[8];
	u8 video;
	u8 language;
	u8 ocarina;
	u8 vipatch;
	u8 ios;
	u8 parentalcontrol;
	u8 errorfix002;
	u8 iosreloadblock;
	u8 loadalternatedol;
	u32 alternatedolstart;
	u8 patchcountrystrings;
	char alternatedolname[40];
};

void CFG_Default(int widescreen); // -1 = non forced mode
void CFG_Load(void);
void lang_defualt();
struct Game_CFG* CFG_get_game_opt(u8 *id);

enum {
	ConsoleLangDefault=0,
	jap,
	eng,
	ger,
	fren,
	esp,
	it,
	dut,
	schin,
	tchin,
	kor,
	settings_language_max // always the last entry
};

enum {
    systemdefault=0,
    discdefault,
	patch,
	pal50,
	pal60,
	ntsc,
	settings_video_max // always the last entry
};

enum {
    off=0,
	on,
	settings_off_on_max // always the last entry
};
enum {
	anti=2,
};

enum {
	i249=0,
	i222,
	i223
};

enum {
	ios249=0,
	ios222,
	settings_cios_max // always the last entry
};

enum {
	all=0,
	pcount,
};

struct SSettings {
	int	video;
	int	language;
	int	ocarina;
	int	vpatch;
	int	ios;
	int	parentalcontrol;
	int	cios;
	int	patchcountrystrings;
	int	wiilight;
	char	covers_path[100];
	char	theme_path[100];
	char	wtheme_path[100];
	char	disc_path[100];
	char	titlestxt_path[100];
	char	language_path[100];
	char	languagefiles_path[100];
	char	oggload_path[100];
	char	ogg_path[150];
	char	dolpath[150];
	char	update_path[150];
	char	Cheatcodespath[100];
	char	TxtCheatcodespath[100];
	short   error002;
};

void CFG_LoadGlobal(void);

char *get_title(struct discHdr *header);
u8 get_block(struct discHdr *header);

void CFG_Cleanup(void);

#ifdef __cplusplus
}
#endif

#endif
